" Vim syntax file
" Language:	initng .i files
" Maintainer:	Elan Ruusame <glen@pld-linux.org>
" URL:		http://glen.alkohol.ee/pld/initng/
" License:	GPL
" Last Change:	$Date: 2005/11/05 01:38:09 $
"
" Syntax highlighting for initng .i files. Inherits from sh.vim and adds
" in the hiliting to start/stop {} blocks. Requires vim 6.3 or later.

if &compatible || v:version < 603
	finish
endif

if exists("b:current_syntax")
	finish
endif

syn case match

let is_bash = 1
unlet! b:current_syntax
syn include @shTop syntax/sh.vim

syn region	initngService			matchgroup=initngServiceHeader start="^\s*\(service\|virtual\|daemon\)\s\+\(\(\w\|[-/*]\)\+\(\s\+:\s\+\(\w\|[-/*]\)\+\)\?\)\s\+{" end="}" contains=@initngServiceCluster
syn cluster initngServiceCluster	contains=initngComment,initngAction,initngServiceOption,initngServiceHeader,initngDelim,initngVariable

syn region	initngAction			matchgroup=initngActionHeader start="^\s*\(start\|stop\)\s*{" end="}" contains=@initngActionCluster
syn cluster initngActionCluster		contains=@shTop

syn match	initngDelim				/[{}]/	contained
syn match	initngComment			/#.*/
syn region	initngString			start=/"/ end=/"/ skip=/\\"/

" option = value
syn match	initngServiceOption		/\w\+\s*=/ contains=initngServiceKeywords contained
" option without value
syn match	initngServiceOption		/\w\+$/ contains=initngServiceKeywords contained

" options with value
syn keyword	initngServiceKeywords	also_stop start start_args stop stop_args daemon daemon_args need use env nice setuid contained
syn keyword	initngServiceKeywords	delay chdir suid start_pause pid_file up_when_pid_set stdout contained
" single options
syn keyword	initngServiceKeywords	last respawn contained
syn match	initngVariable			/\$\w\+/

hi def link	initngComment			Comment
hi def link	initngString			String
hi def link initngServiceKeywords	Define

hi def link	initngServiceHeader		Keyword
hi def link	initngActionHeader		Type
hi def link initngDelim				Delimiter

hi def link	initngVariable			PreProc

let b:current_syntax = "initng"
